<?php
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashoppaymenterip extends hikashopPaymentPlugin
{
	var $accepted_currencies = array( 'USD', 'EUR', 'RUB', 'BYR');
	var $multiple = true;
	var $name = 'erip';
	var $doc_form = 'erip';

	var $pluginConfig = array(
		'merno'   => array('Номер Поставщика', 'input'),
		'web_key' => array('Ключ для авторизации счетов', 'input'),
		'expires' => array('Время действительности счета (число от 1 до 30, если период задан в днях или от 600 до 3600*24, если период задан в секундах)', 'input'),
		'shop'    => array('Название Вашего магазина', 'input'),
	
		'invalid_status'  => array('INVALID_STATUS', 'orderstatus'),
		'pending_status'  => array('PENDING_STATUS', 'orderstatus'),
		'verified_status' => array('VERIFIED_STATUS', 'orderstatus'),
		
	);

	function onBeforeOrderCreate(&$order, &$do) {
        if (parent::onBeforeOrderCreate($order, $do) === true)
            return true;
    }

	function onAfterOrderConfirm(&$order,&$methods,$method_id) {
		parent::onAfterOrderConfirm($order, $methods, $method_id);

		$cancel_url  = HIKASHOP_LIVE . 'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=' . $this->name . '&tmpl=component&result=cancel';
		$success_url = HIKASHOP_LIVE . 'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=' . $this->name . '&tmpl=component&result=success';

		$this->url = 'https://ssl.easypay.by/weborder/?EP_Module=joomla_hikashop_3';

		$this->vars = array(
			'EP_MerNo'		 => @$this->payment_params->merno,
			'EP_OrderNo'	 => $order->order_id,
			'EP_Comment'	 => 'Номер заказа в магазине ' .$order->order_number,
			'EP_OrderInfo'	 => 'Заказ от магазина ' .@$this->payment_params->shop,
			'EP_Sum'		 => $order->cart->full_total->prices[0]->price_value_with_tax,
			'EP_Expires'	 => @$this->payment_params->expires,
			'EP_Hash'		 => md5(@$this->payment_params->merno . @$this->payment_params->web_key . $order->order_id . $order->cart->full_total->prices[0]->price_value_with_tax),
			'EP_Encoding'	 => 'utf-8',
			'EP_PayType'	 => 'PT_ERIP',
			'EP_Success_URL' => $success_url,
			'EP_Cancel_URL'	 => $cancel_url, 

		);

		//Установка статута 
		$history = new stdClass();
		$this->modifyOrder($order->order_id, $this->payment_params->pending_status, $history, true);
		
		return $this->showPage('end');//Загрузка формы на weborder/
	}

	function onPaymentNotification(&$statuses) {

        $response = $_REQUEST;
		//Получение номера заказа
		if($response['result'] == 'notify'){
			$order_id = $response['order_mer_code'];	 		
		}else{
			$order_id = $response['EP_OrderNo'];
		}
       
        $dbOrder = $this->getOrder($order_id);

        $this->loadPaymentParams($dbOrder);
		
		if (empty($this->payment_params)) {
            return false;
        }

        $this->loadOrderData($dbOrder);

        $cancel_url = HIKASHOP_LIVE . 'index.php?option=com_hikashop&ctrl=order&task=cancel_order&order_id=' . $order_id;
        $return_url = HIKASHOP_LIVE . 'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id=' . $order_id . $this->url_itemid;

        if ($response['result'] == 'notify') {//Нотификация
			$values = array();
			$values['order_mer_code']	= $_REQUEST['order_mer_code'];
			$values['sum']				= $_REQUEST['sum'];
			$values['mer_no']			= $_REQUEST['mer_no'];
			$values['card']				= $_REQUEST['card'];
			$values['purch_date']		= $_REQUEST['purch_date'];
			$values['notify_signature'] = $_REQUEST['notify_signature'];
			$values['web_key']			= @$this->payment_params->web_key;

			$hash = md5($values['order_mer_code'] . $values['sum'] . $values['mer_no'] . $values['card'] . $values['purch_date'] . $values['web_key']);

			if ($hash == $values['notify_signature']) {
				//Изменение статуса на "Оплачен"
				$history = new stdClass();
				$this->modifyOrder($order_id, $this->payment_params->verified_status, $history, true);
				header("HTTP/1.0 200 OK");
				print $status = 'OK | the notice is processed'; //Все успешно			
			}else{
				header("HTTP/1.0 400 Bad Request");
				print $status = 'FAILED | incorrect digital signature'; //Ошибка вычисления электронной подписи
			}
            
        } else if($response['result'] == 'cancel') { //Обработка url отмены
			$message = "<font size='4' color='#D1001D'>Ошибка оплаты счета</font>";
            $history = new stdClass();
            $this->modifyOrder($order_id, $this->payment_params->invalid_status, $history, true);
            $this->app->enqueueMessage($message, 'error');
            $this->app->redirect($cancel_url);
            return false;
        }else if($response['result'] == 'success') {//Обработка url успеха
			$message = "<font size='4' color='#00a12d'>Счет добавлен в систему ЕРИП для оплаты.<br/>
			Номер заказа для оплаты: $order_id</font>";
            $this->app->enqueueMessage($message);
            $this->app->redirect($return_url);
            return false;
        }

    }

	function getPaymentDefaultValues(&$element) {
		$element->payment_name = 'ЕРИП';
		$element->payment_description =' Оплата через систему ЕРИП';
		$element->payment_images = '';

		$element->payment_params->debug = false;
		$element->payment_params->expires = 3;

		$element->payment_params->invalid_status='cancelled';
		$element->payment_params->pending_status='created';
		$element->payment_params->verified_status='confirmed';
	}

}

